import { Event } from "@codingame/monaco-vscode-api/vscode/vs/base/common/event";
import { Disposable } from "@codingame/monaco-vscode-api/vscode/vs/base/common/lifecycle";
import { IUserDataSyncLogService } from "@codingame/monaco-vscode-api/vscode/vs/platform/userDataSync/common/userDataSync.service";
import { IUserDataSyncStoreService } from "@codingame/monaco-vscode-api/vscode/vs/platform/userDataSync/common/userDataSync.service";
import { IUserDataSyncAccountService } from "@codingame/monaco-vscode-api/vscode/vs/platform/userDataSync/common/userDataSyncAccount.service";
export interface IUserDataSyncAccount {
    readonly authenticationProviderId: string;
    readonly token: string;
}
export declare class UserDataSyncAccountService extends Disposable implements IUserDataSyncAccountService {
    private readonly userDataSyncStoreService;
    private readonly logService;
    _serviceBrand: any;
    private _account;
    get account(): IUserDataSyncAccount | undefined;
    private _onDidChangeAccount;
    readonly onDidChangeAccount: Event<IUserDataSyncAccount | undefined>;
    private _onTokenFailed;
    readonly onTokenFailed: Event<boolean>;
    private wasTokenFailed;
    constructor(userDataSyncStoreService: IUserDataSyncStoreService, logService: IUserDataSyncLogService);
    updateAccount(account: IUserDataSyncAccount | undefined): Promise<void>;
}
